#if !defined(AFX_FCEDIT_H__0AAFEEE1_07EE_11D4_A4C6_00A0CC307F9C__INCLUDED_)
#define AFX_FCEDIT_H__0AAFEEE1_07EE_11D4_A4C6_00A0CC307F9C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FCEdit.h : header file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.


/////////////////////////////////////////////////////////////////////////////
// CFCEdit dialog

#include "FlashQuizDoc.h"

class CFCEdit : public CDialog
{
// Construction
public:
	CFCEdit(CWnd* pParent = NULL);   // standard constructor

	// Member variables.
	int			m_intItem;
	BOOL		m_bMode;
	BOOL		m_bFontChanged;
	CQuestion	*m_pQuestion;

// Dialog Data
	//{{AFX_DATA(CFCEdit)
	enum { IDD = IDD_FLASHCARD_EDIT };
	CButton	m_cmdFont;
	CButton	m_cmdOK;
	CButton	m_cmdCancel;
	CEdit	m_txtTimeLimit;
	CEdit	m_txtReduceTime;
	CEdit	m_txtReduceScore;
	CEdit	m_txtAnswer;
	CEdit	m_txtQuestion;
	CEdit	m_txtBitmap;
	CSpinButtonCtrl	m_spnTime;
	CSpinButtonCtrl	m_spnScore;
	CSpinButtonCtrl	m_spnReduceTime;
	CSpinButtonCtrl	m_spnReduceScore;
	CButton	m_cmdBrowse;
	CButton	m_chkTimeLimit;
	CButton	m_chkReduce;
	CButton	m_chkBitmap;
	BOOL	m_bUseBitmap;
	BOOL	m_bReduce;
	BOOL	m_bTimeLimit;
	CString	m_strBitmap;
	CString	m_strQuestion;
	CString	m_strAnswer;
	UINT	m_intReduceScore;
	UINT	m_intReduceTime;
	UINT	m_intScore;
	UINT	m_intTimeLimit;
	BOOL	m_bCustomFont;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFCEdit)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Member variables.
	LOGFONT m_fontCustom;

	// Member functions.
	int Do_Choose_Font();
	void Enable_Add_Button();
	void Enable_Numerics();
	BOOL Fields_Changed();
	BOOL Validate_Fields();

	// Generated message map functions
	//{{AFX_MSG(CFCEdit)
	afx_msg void OnchkBitmap();
	afx_msg void OnchkReduce();
	afx_msg void OnchkTimeLimit();
	afx_msg void OncmdBrowse();
	afx_msg void OncmdPreview();
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OncmdFont();
	afx_msg void OnChangetxtQuestion();
	afx_msg void OnChangetxtBitmap();
	afx_msg void OnchkCustomFont();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FCEDIT_H__0AAFEEE1_07EE_11D4_A4C6_00A0CC307F9C__INCLUDED_)
