#if !defined(AFX_FLASHCARD_H__C7DAC821_074C_11D4_A4C6_00A0CC307F9C__INCLUDED_)
#define AFX_FLASHCARD_H__C7DAC821_074C_11D4_A4C6_00A0CC307F9C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FlashCard.h : header file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.


#include "FlashQuizDoc.h"
#include "MyPicture.h"
#include "NoCopyEdit.h"

/////////////////////////////////////////////////////////////////////////////
// CFlashCard dialog

class CFlashCard : public CDialog
{
// Construction
public:
	// Member variables.
	int			m_intQuestion;	// Question sequence number.
	int			m_intTimeLeft;	// Time remaining for this question. 0 == no time limit.
	BOOL		m_bIsMaximized;	// Window state flag.
	BOOL		m_bPreviewMode;	// Preview mode flag.
	CQuestion*	m_pQuestion;	// Pointer to the current question object.

	// Member functions.
	CFlashCard(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CFlashCard)
	enum { IDD = IDD_FLASHCARD };
	CStatic	m_lblEnter;
	CButton	m_fraStatus;
	CButton	m_cmdCancel;
	CEdit	m_txtResponse;
	CStatic	m_lblScore;
	CStatic	m_lblQuizTime;
	CStatic	m_lblQuestionTime;
	CStatic	m_lblCumulative;
	CNoCopyEdit	m_txtQuestion;
	CStatic	m_lblAnswer;
	CMyPicture	m_fraPicture;
	CButton	m_cmdWrong;
	CButton	m_cmdShow;
	CButton	m_cmdRight;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFlashCard)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	int m_intTextEnd;
	int m_intTextStart;
	// Member variables.
	int m_intReduceTimer;	// Interval before score is reduced. -1 = don't reduce.
	int m_intActualScore;	// Amount to reduce score when interval expires.
	BOOL m_bShowText;		// Flag: TRUE == question has text.
	BOOL m_bShowGraphic;	// Flag: TRUE == question has a graphic.
	BOOL m_bAnswerShown;	// Flag: TRUE == answer has been displayed.
	BOOL m_bHasCustomFont;	// Flag: TRUE == use custom font for question text.
	BOOL m_bDisableTimer;	// Flag: TRUE == ignore timer messages.
	CFont m_fontCustom;		// Custom font for question text.
	HBITMAP m_hBitmap;		// Handle to question image.

	// Member functions.
	BOOL Query_Abort(void);
	void Update_Question_Time(void);
	void Set_Question_Position(void);
	void Update_Point_Value(void);

	// Generated message map functions
	//{{AFX_MSG(CFlashCard)
	afx_msg void OncmdRight();
	afx_msg void OncmdShow();
	afx_msg void OncmdWrong();
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetfocustxtQuestion();
	afx_msg void OnKillfocustxtQuestion();
	//}}AFX_MSG
	// App-specific message handlers.
	afx_msg LONG OnUpdateTimer(WPARAM, LPARAM);
	afx_msg LONG OnQuestionTimeout(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FLASHCARD_H__C7DAC821_074C_11D4_A4C6_00A0CC307F9C__INCLUDED_)
