// FlashQuiz.h : main header file for the FLASHQUIZ application
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.


#if !defined(AFX_FLASHQUIZ_H__D88B5245_E79C_11D3_A4C6_00A0CC307F9C__INCLUDED_)
#define AFX_FLASHQUIZ_H__D88B5245_E79C_11D3_A4C6_00A0CC307F9C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "FlashQuizDoc.h"

#define MY_UPDATE_TIMER (WM_APP + 1)
#define MY_QUESTION_TIMEOUT (WM_APP + 2)
#define MY_TAKE_QUIZ (WM_APP + 3)


/////////////////////////////////////////////////////////////////////////////
// CFlashQuizApp:
// See FlashQuiz.cpp for the implementation of this class
//

class CFlashQuizApp : public CWinApp
{
public:
	// Member functions
	CFlashQuizApp();	// Default constructor
	BOOL Find_Image_File(LPCTSTR szFileName, CString& strFileName);
	void Update_Quiz_Time(CStatic& m_lblDisplay);
	BOOL Randomize_List(int *pIndexArray, int iCount);
	BYTE *Scramble(CString& strText);
	BOOL UnScramble(BYTE * pData, int iDataLen, CString& strResult);
	void ShowQuestionTimeout(CDialog* pParent, LPARAM lParam = 0);
	BOOL Check_Bitmap_Header(CString &strFileName);
	// Member variables

	BOOL m_bEditFile;
	CString m_strFileName;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFlashQuizApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CFlashQuizApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
protected:
	// Member functions.
	void Do_Uninstall();
	BOOL Check_Association();
	LONG Set_Default_Value(HKEY hKey, LPCTSTR pszValue);
	BOOL Do_File_Removal(void);
	void Set_Associations();
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FLASHQUIZ_H__D88B5245_E79C_11D3_A4C6_00A0CC307F9C__INCLUDED_)
