#if !defined(AFX_FLASHQUIZDOC_H__F512CF01_E937_11D3_A4C6_00A0CC307F9C__INCLUDED_)
#define AFX_FLASHQUIZDOC_H__F512CF01_E937_11D3_A4C6_00A0CC307F9C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FlashQuizDoc.h : header file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.

////////////////////////////////////
// Declaration of the CQuestion class.

class CQuestion
{
public:
	// Member functions.
	CQuestion();		// Default constructor.
	~CQuestion();		// Destructor
	BOOL Set_Font(LOGFONT *pLogFont = NULL);

	// Member variables.
	int			m_intNumAnswers;	// Answer count. 0 = "flash card".
	int			m_intScore;			// Maximum possible score.
	int			m_intTime;			// Time allowed. 0 = no limit.
	int			m_intTimeDeduct;	// Interval before score is reduced. 0 = no deduction.
	int			m_intScoreDeduct;	// Amount to reduce score at each interval.
	int			m_intActualScore;	// Score given.
	BOOL		m_bCustomFont;		// Custom font flag.
	BOOL		m_bAllowMultiple;	// Single/multiple answer flag.
	BOOL		m_bCorrect[5];		// Correct answer(s).
	BOOL		m_bAnswers[5];		// Answers given (for score log)
	BOOL		m_bTimedOut;		// Timeout flag (for score log)
	BOOL		m_bPresented;		// Question presented flag (for score log).
	CString		m_strQuestion;		// Question text.
	CString		m_strAnswers[5];	// Answer text.
	CString		m_strBitmapFile;	// Filespec for optional image.
	LOGFONT		*m_pFont;			// Pointer to custom font data.
private:
};

/////////////////////////////////////////////////////////////////////////////
// CFlashQuizDoc document

class CFlashQuizDoc : public CDocument
{

// Don't need this since we're not using Document/View architecture.
//protected:
//	CFlashQuizDoc();           // protected constructor used by dynamic creation
//	DECLARE_DYNCREATE(CFlashQuizDoc)

// Instead, make the constructor public so our app can call it directly.
public:
	CFlashQuizDoc();           // protected constructor used by dynamic creation
	virtual ~CFlashQuizDoc();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFlashQuizDoc)
	public:
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
	virtual void DeleteContents();
	protected:
	virtual BOOL OnNewDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	// Member variables.
	BOOL		m_bCustomFont;				// Default custom font flag.
	BOOL		m_bShowCorrect;				// "Review answers" flag.
	int			m_intPossibleScore;			// Possible score for entire quiz.
	int			m_intTotalScore;			// Actual score for entire quiz.
	int			m_intTimeLeft;				// Quiz time remaining (seconds).
	int			m_intDefaultScore;			// Default score for new questions.
	int			m_intDefaultQuestionTime;	// Default time limit for new questions.
	int			m_intDefaultTimeDeduct;		// Default reduce score interval for new questions.
	int			m_intDefaultScoreDeduct;	// Default reduce score amount for new questions.
	int			m_intQuestionCount;			// Number of questions present.
	int			m_intQuizType;				// Type of quiz (0 == mult. choice, 1 = flash card).
	BOOL		m_bLoadFail;				// Load failure flag.
	BOOL		m_bTimeLimit;				// Time limit flag.
	BOOL		m_bLog;						// Log results flag.
	UINT		m_intTimeLimit;				// Quiz time limit (minutes).
	BOOL		m_bRandomA;					// Randomize answers flag.
	BOOL		m_bRandomQ;					// Randomize questions flag.
	CString		m_strPassword;				// Password.
	CString		m_strFileName;				// Current document filename.
	CString		m_strLogFileName;			// Log file name.
	LOGFONT		m_fontCustom;				// Default custom font for new questions.

	// Member functions.
	int			Add_Question(CQuestion *pQuestion);
	int			Get_Save_Name(CWnd* pParent);
	BOOL		Insert_Question(int iPos, CQuestion* pNewQuestion);
	BOOL		Do_Save(CWnd* pParent);
	BOOL		Move_Item(BOOL bDirection, int nItem);
	BOOL		Read_String(CArchive& ar, CString& strData);
	BOOL		Write_String(CArchive& ar, BYTE *pData, int iLen);
	BOOL		Do_Query_Save(CWnd* pParent);
	BOOL		Log_Quiz(LPCTSTR pszComment);
	void		Delete_Question(int iIndex);
	void		Export_Log(LPCTSTR strFileName, CWnd* pParent);
	void		Set_File_Name(LPCTSTR pszName);
	void		Reset_Quiz(void);
	CQuestion*	Get_Question(int iQuestion);
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Protected member variables and functions.
protected:
	BOOL Write_Line(CFile& file, CString& strLine);
	CQuestion * m_pQuestionArray[512];

	// Generated message map functions
protected:
	//{{AFX_MSG(CFlashQuizDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FLASHQUIZDOC_H__F512CF01_E937_11D3_A4C6_00A0CC307F9C__INCLUDED_)
