#if !defined(AFX_MULTCHOICE_H__80D191E1_062D_11D4_A4C6_00A0CC307F9C__INCLUDED_)
#define AFX_MULTCHOICE_H__80D191E1_062D_11D4_A4C6_00A0CC307F9C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MultChoice.h : header file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.

#include "FlashQuizDoc.h"
#include "MyPicture.h"
#include "NoCopyEdit.h"

/////////////////////////////////////////////////////////////////////////////
// CMultChoice dialog

class CMultChoice : public CDialog
{
// Construction
public:
	int m_intTextEnd;
	int m_intTextStart;
	CMultChoice(CWnd* pParent = NULL);   // standard constructor

	int m_intQuestion;
	BOOL m_bPreviewMode;
	BOOL m_bIsMaximized;
	CQuestion *m_pQuestion;

// Dialog Data
	//{{AFX_DATA(CMultChoice)
	enum { IDD = IDD_MULTCHOICE };
	CButton	m_fraChoose;
	CButton	m_fraStatus;
	CButton	m_cmdOK;
	CButton	m_cmdQuit;
	CStatic	m_lblScore;
	CStatic	m_lblQuizTime;
	CStatic	m_lblQuestionTime;
	CStatic	m_lblCumulative;
	CMyPicture	m_fraGraphic;
	CNoCopyEdit	m_txtQuestion;
	//}}AFX_DATA
	// Note that arrays must be outside the ClassWizard's block,
	// as the Class Wizard's parser gags on the [] array subscript delimiters.
	CButton	m_chkAnswer[5];
	BOOL	m_bAnswer[5];


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMultChoice)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Member variables
	BOOL		m_bHasCustomFont;		// Custom font flag.
	CFont		m_fontCustom;			// Custom font.
	int			m_intReduceTimer;		// Interval before score is reduced (-1 = don't reduce).
	int			m_iAnswerIndex[5];		// Answer array.
	int			m_intAnswerCount;		// Number of answers present.
	int			m_intTimeLeft;			// Time remaining (seconds) for this question.
	int			m_intActualScore;		// Actual score for this question.
	BOOL		m_bReviewMode;			// Flag: TRUE == user is viewing correct answer.
	BOOL		m_bShowGraphic;			// Flag: Question has a graphic.
	BOOL		m_bShowText;			// Flag: Question has text.
	BOOL		m_bDisableTimer;		// Flag: Ignore timer events.
	HBITMAP		m_hBitmap;				// Handle to thsi question's graphic.

	// Member functions
	void Update_Question_Time();		// Update question time remaining.
	void Set_Question_Position();		// Set position of question text and/or graphic.
	void Update_Point_Value();			// Update current score display.
	void Review_Answer(BOOL bTimeout);	// Let user view the correct answer.

	// Generated message map functions
	//{{AFX_MSG(CMultChoice)
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	afx_msg void OncmdQuit();
	afx_msg void OnClose();
	virtual void OnOK();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKillfocustxtQuestion();
	afx_msg void OnSetfocustxtQuestion();
	//}}AFX_MSG
	afx_msg void OnchkAnswer(int nID);
	afx_msg LONG OnUpdateTimer(WPARAM, LPARAM);
	afx_msg LONG OnQuestionTimeout(WPARAM, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MULTCHOICE_H__80D191E1_062D_11D4_A4C6_00A0CC307F9C__INCLUDED_)
