// NoCopyEdit.cpp : implementation file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.


// This implements an edit control that has no context menu
// and ignores the "Copy" command (i.e., Ctrl+C) from the keyboard.
// Thus, the user cannot copy text from this control.

#include "stdafx.h"
//#include "flashquiz.h"
#include "NoCopyEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNoCopyEdit

CNoCopyEdit::CNoCopyEdit()
{
}

CNoCopyEdit::~CNoCopyEdit()
{
}


BEGIN_MESSAGE_MAP(CNoCopyEdit, CEdit)
	//{{AFX_MSG_MAP(CNoCopyEdit)
	ON_WM_CONTEXTMENU()
	ON_MESSAGE(WM_COPY, OnCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNoCopyEdit message handlers

// Kill the Copy command by "swallowing" the WM_COPY message.
long CNoCopyEdit::OnCopy(WPARAM, LPARAM)
{
	return 0L;
}


// Kill the context menu.
void CNoCopyEdit::OnContextMenu(CWnd* pWnd, CPoint point) 
{
}
