// ParmDlg.cpp : implementation file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.

#include "stdafx.h"
#include "flashquiz.h"
#include "PwdDlg.h"
#include "ApplyDefaultDlg.h"
#include "ParmDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CFlashQuizApp theApp;
extern CFlashQuizDoc theDoc;
extern int g_intDefaultQuestionTime;
extern int g_intDefaultTimeDeduct;
extern int g_intDefaultScoreDeduct;

/////////////////////////////////////////////////////////////////////////////
// CParmDlg dialog


CParmDlg::CParmDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParmDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParmDlg)
	m_bRandomAnswers = FALSE;
	m_bRandomQuestions = FALSE;
	m_bLogResults = FALSE;
	m_bTimeLimit = FALSE;
	m_intMinutes = 0;
	m_intQuizType = -1;
	m_intScore = 0;
	m_bDefaultTimeLimit = FALSE;
	m_intDefaultTimeLimit = 0;
	m_bReduce = FALSE;
	m_intReduceScore = 0;
	m_intReduceTime = 0;
	m_bShowCorrect = FALSE;
	m_bFont = FALSE;
	//}}AFX_DATA_INIT
}


void CParmDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParmDlg)
	DDX_Control(pDX, IDC_cmdChangeFont, m_cmdChangeFont);
	DDX_Control(pDX, IDC_cmdApplyFont, m_cmdApplyFont);
	DDX_Control(pDX, IDC_chkFont, m_chkFont);
	DDX_Control(pDX, IDC_chkShowCorrect, m_chkShowCorrect);
	DDX_Control(pDX, IDC_cmdExportLog, m_cmdExportLog);
	DDX_Control(pDX, IDC_cmdDeleteLog, m_cmdDeleteLog);
	DDX_Control(pDX, IDC_cmdApplyAll, m_cmdApplyAll);
	DDX_Control(pDX, IDC_txtScore, m_txtScore);
	DDX_Control(pDX, IDC_txtReduceTime, m_txtReduceTime);
	DDX_Control(pDX, IDC_txtReduceScore, m_txtReduceScore);
	DDX_Control(pDX, IDC_spnScore, m_spnScore);
	DDX_Control(pDX, IDC_spnReduceTime, m_spnReduceTime);
	DDX_Control(pDX, IDC_spnReduceScore, m_spnReduceScore);
	DDX_Control(pDX, IDC_chkReduce, m_chkReduce);
	DDX_Control(pDX, IDC_spnTime, m_spnTime);
	DDX_Control(pDX, IDC_txtTimeLimit, m_txtDefaultTimeLimit);
	DDX_Control(pDX, IDC_chkRandomA, m_chkRandomA);
	DDX_Control(pDX, IDC_spnMinutes, m_spnMinutes);
	DDX_Control(pDX, IDC_optType0, m_optType0);
	DDX_Control(pDX, IDC_optType1, m_optType1);
	DDX_Control(pDX, IDC_txtMinutes, m_txtMinutes);
	DDX_Control(pDX, IDC_lblMinutes, m_lblMinutes);
	DDX_Check(pDX, IDC_chkRandomA, m_bRandomAnswers);
	DDX_Check(pDX, IDC_chkRandomQ, m_bRandomQuestions);
	DDX_Check(pDX, IDC_chkLog, m_bLogResults);
	DDX_Check(pDX, IDC_chkLimit, m_bTimeLimit);
	DDX_Text(pDX, IDC_txtMinutes, m_intMinutes);
	DDX_Radio(pDX, IDC_optType0, m_intQuizType);
	DDX_Text(pDX, IDC_txtScore, m_intScore);
	DDX_Check(pDX, IDC_chkTimeLimit, m_bDefaultTimeLimit);
	DDX_Text(pDX, IDC_txtTimeLimit, m_intDefaultTimeLimit);
	DDX_Check(pDX, IDC_chkReduce, m_bReduce);
	DDX_Text(pDX, IDC_txtReduceScore, m_intReduceScore);
	DDX_Text(pDX, IDC_txtReduceTime, m_intReduceTime);
	DDX_Check(pDX, IDC_chkShowCorrect, m_bShowCorrect);
	DDX_Check(pDX, IDC_chkFont, m_bFont);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CParmDlg, CDialog)
	//{{AFX_MSG_MAP(CParmDlg)
	ON_BN_CLICKED(IDC_chkLimit, OnchkLimit)
	ON_BN_CLICKED(IDC_chkLog, OnchkLog)
	ON_BN_CLICKED(IDC_cmdPassword, OncmdPassword)
	ON_BN_CLICKED(IDC_chkReduce, OnchkReduce)
	ON_BN_CLICKED(IDC_chkTimeLimit, OnchkTimeLimit)
	ON_BN_CLICKED(IDC_cmdApplyAll, OncmdApplyAll)
	ON_BN_CLICKED(IDC_cmdExportLog, OncmdExportLog)
	ON_BN_CLICKED(IDC_cmdDeleteLog, OncmdDeleteLog)
	ON_BN_CLICKED(IDC_cmdChangeFont, OncmdChangeFont)
	ON_BN_CLICKED(IDC_cmdApplyFont, OncmdApplyFont)
	ON_BN_CLICKED(IDC_chkFont, OnchkFont)
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_optType0, IDC_optType1, OnoptType)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParmDlg message handlers

void CParmDlg::OnchkLimit() 
{
	UpdateData(TRUE);
	m_txtMinutes.EnableWindow(m_bTimeLimit);
	m_spnMinutes.EnableWindow(m_bTimeLimit);
	
}

void CParmDlg::OnchkLog() 
{
	UpdateData(TRUE);
}

void CParmDlg::OncmdPassword() 
{
	CPwdDlg dlg;
	dlg.m_intMode = 2;
	dlg.DoModal();
}

BOOL CParmDlg::OnInitDialog() 
{
	BOOL	bStatus = FALSE;
	CFile	file;
	CFont* pFont;

	CDialog::OnInitDialog();

	if (!theDoc.m_strLogFileName.IsEmpty())
	{
		if (file.Open(theDoc.m_strLogFileName, CFile::modeRead | CFile::shareDenyNone, NULL))
		{
			bStatus = TRUE;
			file.Close();
		}
	}
	m_cmdExportLog.EnableWindow(bStatus);
	m_cmdDeleteLog.EnableWindow(bStatus);
	m_bTimeLimit = theDoc.m_bTimeLimit;
	if (m_bTimeLimit)
		m_intMinutes = theDoc.m_intTimeLimit;
	else
		m_intMinutes = 1;
	m_spnMinutes.SetRange(1, 300);
	m_spnMinutes.SetPos(m_intMinutes);
	m_spnTime.SetRange(1, 300);
	m_spnScore.SetRange(1, 50);
	m_spnReduceScore.SetRange(1, 10);
	m_spnReduceTime.SetRange(1, 300);
	m_intQuizType = theDoc.m_intQuizType;
	m_bLogResults = theDoc.m_bLog;
	m_bRandomAnswers = theDoc.m_bRandomA;
	m_bRandomQuestions = theDoc.m_bRandomQ;
	m_bFont = theDoc.m_bCustomFont;
	m_bShowCorrect = theDoc.m_bShowCorrect;
	m_txtMinutes.EnableWindow(m_bTimeLimit);
	m_spnMinutes.EnableWindow(m_bTimeLimit);
	m_optType0.EnableWindow(m_bInitialParms);
	m_optType1.EnableWindow(m_bInitialParms);
	m_chkRandomA.EnableWindow(m_intQuizType == 0);
	m_chkShowCorrect.EnableWindow(m_intQuizType == 0);
	m_cmdChangeFont.EnableWindow(m_bFont);
	m_cmdApplyFont.EnableWindow(m_bFont && theDoc.m_intQuestionCount > 0);
	m_intScore = theDoc.m_intDefaultScore;
	m_spnScore.SetPos(m_intScore);
	if (m_bFont)
	{
		m_fontCustom = theDoc.m_fontCustom;
	}
	else
	{
		pFont = GetFont();
		pFont->GetLogFont(&m_fontCustom);
	}
	if (theDoc.m_intDefaultQuestionTime == 0)
	{
		m_intDefaultTimeLimit = 1;
		m_bDefaultTimeLimit = FALSE;
	}
	else
	{
		m_intDefaultTimeLimit = theDoc.m_intDefaultQuestionTime;
		m_bDefaultTimeLimit = TRUE;
	}
	m_spnTime.SetPos(m_intDefaultTimeLimit);
	if (theDoc.m_intDefaultTimeDeduct == 0)
	{
		m_intReduceTime = 1;
		m_intReduceScore = 1;
		m_bReduce = FALSE;
	}
	else
	{
		m_intReduceTime = theDoc.m_intDefaultTimeDeduct;
		m_intReduceScore = theDoc.m_intDefaultScoreDeduct;
		m_bReduce = TRUE;
	}
	m_spnReduceTime.SetPos(m_intReduceTime);
	m_spnReduceScore.SetPos(m_intReduceScore);
	UpdateData(FALSE);
	Enable_Numerics();
	m_cmdApplyAll.EnableWindow(theDoc.m_intQuestionCount > 0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CParmDlg::OnOK() 
{
	UpdateData(TRUE);
	if (m_bTimeLimit)
	{
		if (m_intMinutes < 1)
		{
			MessageBox("Time Limit cannot be less than one minute", "FlashQuiz", MB_ICONINFORMATION);
			m_intMinutes = 1;
			m_spnMinutes.SetPos(m_intMinutes);
			UpdateData(FALSE);
			m_txtMinutes.SetFocus();
			return;
		}
		else if (m_intMinutes > 300)
		{
			MessageBox("Time limit cannot exceed 300 minutes.", "FlashQuis", MB_ICONINFORMATION);
			m_intMinutes = 300;
			m_spnMinutes.SetPos(m_intMinutes);
			UpdateData(FALSE);
			m_txtMinutes.SetFocus();
			return;
		}
	}
	if (!Validate_Defaults())
		return;
	if (Value_Changed())
		theDoc.SetModifiedFlag(TRUE);
	theDoc.m_bTimeLimit = m_bTimeLimit;
	theDoc.m_intTimeLimit = m_intMinutes;
	theDoc.m_bRandomA = m_bRandomAnswers;
	theDoc.m_bRandomQ = m_bRandomQuestions;
	theDoc.m_bShowCorrect = m_bShowCorrect;
	theDoc.m_bLog = m_bLogResults;
	theDoc.m_bCustomFont = m_bFont;
	if (m_bFont)
		theDoc.m_fontCustom = m_fontCustom;
	theDoc.m_intQuizType = m_intQuizType;
	theDoc.m_intDefaultScore = m_intScore;
	if (m_bDefaultTimeLimit)
		theDoc.m_intDefaultQuestionTime = m_intDefaultTimeLimit;
	else
		theDoc.m_intDefaultQuestionTime = 0;
	if (m_bDefaultTimeLimit && m_bReduce)
	{
		theDoc.m_intDefaultScoreDeduct = m_intReduceScore;
		theDoc.m_intDefaultTimeDeduct = m_intReduceTime;
	}
	else
	{
		theDoc.m_intDefaultScoreDeduct = 0;
		theDoc.m_intDefaultTimeDeduct = 0;
	}
	CDialog::OnOK();
}

// Disable "Randomize Answers" and "Allow multiple ..." checkboxes
// when "Flash Card" option is selected.
void CParmDlg::OnoptType(UINT nIndex) 
{
	BOOL bEnable;

	UpdateData(TRUE);
	bEnable = (m_intQuizType == 0);
	m_chkRandomA.EnableWindow(bEnable);
	m_chkShowCorrect.EnableWindow(bEnable);
}

void CParmDlg::OnchkReduce() 
{
	Enable_Numerics();	
}

void CParmDlg::OnchkTimeLimit() 
{
	Enable_Numerics();
}

void CParmDlg::OncmdApplyAll() 
{
	int					i;
	CQuestion			*pQuestion;
	CApplyDefaultDlg	dlg;

	UpdateData(TRUE);
	if (!Validate_Defaults())
		return;
	if (dlg.DoModal() != IDOK)
		return;

	for (i = 0; i < theDoc.m_intQuestionCount; i++)
	{
		pQuestion = theDoc.Get_Question(i);
		if (dlg.m_bApplyScore)
			pQuestion->m_intScore = m_intScore;
		if (dlg.m_bApplyTime)
		{
			if (m_bDefaultTimeLimit)
				pQuestion->m_intTime = m_intDefaultTimeLimit;
			else
				pQuestion->m_intTime = 0;
		}
		if (dlg.m_bApplyReduce)
		{
			if (m_bReduce)
			{
				pQuestion->m_intScoreDeduct = m_intReduceScore;
				pQuestion->m_intTimeDeduct = m_intReduceTime;
			}
			else
			{
				pQuestion->m_intScoreDeduct = 0;
				pQuestion->m_intTimeDeduct = 0;
			}
		}
	}
	theDoc.SetModifiedFlag(TRUE);
}

void CParmDlg::Enable_Numerics()
{
	UpdateData(TRUE);
	BOOL bEnable = m_bDefaultTimeLimit;
	m_txtDefaultTimeLimit.EnableWindow(bEnable);
	m_spnTime.EnableWindow(bEnable);
	m_chkReduce.EnableWindow(bEnable);
	bEnable = m_bDefaultTimeLimit && m_bReduce;
	m_txtReduceTime.EnableWindow(bEnable);
	m_spnReduceTime.EnableWindow(bEnable);
	m_txtReduceScore.EnableWindow(bEnable);
	m_spnReduceScore.EnableWindow(bEnable);
}

BOOL CParmDlg::Validate_Defaults()
{
	if (m_bDefaultTimeLimit)
	{
		if (m_intDefaultTimeLimit < 1)
		{
			MessageBox("Default time limit cannot be less than one second", "FlashQuiz", MB_ICONINFORMATION);
			m_intDefaultTimeLimit = 1;
			m_spnTime.SetPos(m_intDefaultTimeLimit);
			UpdateData(FALSE);
			m_txtDefaultTimeLimit.SetFocus();
			return FALSE;
		}
		else if (m_intDefaultTimeLimit > 300)
		{
			MessageBox("Default time limit cannot exceed 300 seconds.", "FlashQuis", MB_ICONINFORMATION);
			m_intDefaultTimeLimit = 300;
			m_spnTime.SetPos(m_intDefaultTimeLimit);
			UpdateData(FALSE);
			m_txtDefaultTimeLimit.SetFocus();
			return FALSE;
		}
	}
	if (m_intScore < 1)
	{
		MessageBox("Default score must be at least 1 point.");
		m_spnScore.SetPos(1);
		m_intScore = 1;
		UpdateData(FALSE);
		m_txtScore.SetFocus();
		return FALSE;
	}
	else if (m_intScore > 50)
	{
		MessageBox("Default score cannot exceed 50 points.");
		m_spnScore.SetPos(50);
		m_intScore = 50;
		UpdateData(FALSE);
		m_txtScore.SetFocus();
		return FALSE;
	}
	return TRUE;
}

void CParmDlg::OncmdExportLog() 
{
	int		iResult;
	BOOL	bExists;
	CFile	file;
	CString strOutFileName;

	if (file.Open(theDoc.m_strLogFileName, CFile::modeRead | CFile::shareDenyNone, NULL))
	{
		file.Close();
		bExists = TRUE;
	}
	else
		bExists = FALSE;
	if (!bExists)
	{
		MessageBox("Log file has been deleted by some other program!", "FlashQuiz", MB_ICONINFORMATION);
		m_cmdExportLog.EnableWindow(bExists);
		m_cmdDeleteLog.EnableWindow(bExists);
		return;
	}	
	CFileDialog dlg(FALSE, ".txt", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST, "Text files (*.txt)|*.txt|Log files (*.log)|*.log|All Files (*.*)|*.*||", this);
	dlg.m_ofn.lpstrTitle = "Save Quiz Log As:";
	iResult = dlg.DoModal();
	if (iResult != IDOK)
		return;
	strOutFileName = dlg.GetPathName();
	if (strOutFileName.CompareNoCase(theDoc.m_strLogFileName) == 0)
	{
		MessageBox("Cannot export log file to itself!", "FlashQuiz", MB_ICONINFORMATION);
		return;
	}
	theDoc.Export_Log(strOutFileName, this);
}

void CParmDlg::OncmdDeleteLog() 
{
	BOOL	bExists;
	CFile	file;
	CString strTemp;

	if (MessageBox("This will delete the log file permanently.\nAre you sure you want to do this?", "FlashQuiz", MB_ICONQUESTION | MB_YESNO) != IDYES)
		return;
	if (file.Open(theDoc.m_strLogFileName, CFile::modeRead | CFile::shareDenyNone, NULL))
	{
		file.Close();
		bExists = TRUE;
	}
	else
		bExists = FALSE;
	if (bExists)
	{
		try
		{
			CFile::Remove(theDoc.m_strLogFileName);
		}
		catch (CFileException *e)
		{
			e->Delete();
			bExists = TRUE;
			strTemp.Format("Could not delete %s\nFile is either marked as Read-Only\nor is in use by another program", theDoc.m_strLogFileName);
			MessageBox(strTemp, "FlashQuiz", MB_ICONINFORMATION);
			return;
		}
		bExists = FALSE;
	}
	m_cmdExportLog.EnableWindow(bExists);
	m_cmdDeleteLog.EnableWindow(bExists);
}

// Compares displayed settings against existing ones.
// Returns TRUE if any setting has changed.
BOOL CParmDlg::Value_Changed()
{
	if (theDoc.m_bTimeLimit != m_bTimeLimit)
		return TRUE;
	if (theDoc.m_intTimeLimit != m_intMinutes)
		return TRUE;
	if (theDoc.m_bRandomA != m_bRandomAnswers)
		return TRUE;
	if (theDoc.m_bRandomQ != m_bRandomQuestions)
		return TRUE;
	if (theDoc.m_bLog != m_bLogResults)
		return TRUE;
	if (theDoc.m_intDefaultScore != (int) m_intScore)
		return TRUE;
	if (theDoc.m_bTimeLimit != m_bTimeLimit)
		return TRUE;
	if (m_bTimeLimit && theDoc.m_intTimeLimit != (int) m_intDefaultTimeLimit)
		return TRUE;
	if (m_bDefaultTimeLimit != (theDoc.m_intDefaultQuestionTime != 0))
		return TRUE;
	else
	{
		if (m_bDefaultTimeLimit && theDoc.m_intDefaultQuestionTime != (int) m_intDefaultTimeLimit)
			return TRUE;
	}
	if (m_bReduce != (theDoc.m_intDefaultTimeDeduct != 0))
		return TRUE;
	else
	{
		if (m_bReduce &&
			((theDoc.m_intDefaultScoreDeduct != (int) m_intReduceScore) ||
			 (theDoc.m_intDefaultTimeDeduct != (int) m_intReduceTime)))
			 return TRUE;
	}
	if (m_bShowCorrect != theDoc.m_bShowCorrect)
		return TRUE;
	if (m_intQuizType == 1)
	{
		if (m_bFont != theDoc.m_bCustomFont)
			return TRUE;
	}
	return FALSE;
}

void CParmDlg::OncmdChangeFont()
{
	Do_Choose_Font();
}

void CParmDlg::OncmdApplyFont() 
{
	int i;
	CQuestion* pQuestion;

	UpdateData(TRUE);
	for (i = 0; i < theDoc.m_intQuestionCount; i++)
	{
		pQuestion = theDoc.Get_Question(i);
		if (m_bFont)
		{
			pQuestion->Set_Font(&m_fontCustom);
		}
		else
		{
			pQuestion->Set_Font(NULL);
		}
	}
	theDoc.SetModifiedFlag(TRUE);
}

// Called when "custom font" box is clicked.
void CParmDlg::OnchkFont() 
{
	UpdateData(TRUE);	// Retrieve the setting.
	if (m_bFont)		// If box was just checked,
	{
		if (Do_Choose_Font() != IDOK)	// Let the user choose the custom font.
		{
			m_bFont = FALSE;			// If he canceled, clear the checkbox.
			UpdateData(FALSE);
		}
	}
	m_cmdChangeFont.EnableWindow(m_bFont);
	m_cmdApplyFont.EnableWindow(m_bFont && theDoc.m_intQuestionCount > 0);
}

int CParmDlg::Do_Choose_Font()
{
	int			iResult;
	CFontDialog* pDlg;		// Create a common Font dialog object.
	LOGFONT		font;
	
	// Create font dialog with current font data.
	pDlg = new CFontDialog(&m_fontCustom);
	iResult = pDlg->DoModal();
	if (iResult == IDOK)
	{
		// Retrieve current font information.
		pDlg->GetCurrentFont(&font);
		// Copy to local storage.
		m_fontCustom = font;
	}
	delete pDlg;
	return iResult;
}
