#if !defined(AFX_QEDIT_H__3509F441_F049_11D3_A4C6_00A0CC307F9C__INCLUDED_)
#define AFX_QEDIT_H__3509F441_F049_11D3_A4C6_00A0CC307F9C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// QEdit.h : header file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.

#include "FlashQuizDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CQEdit dialog

class CQEdit : public CDialog
{
// Construction
public:
	void Enable_Add_Button();
	CQEdit(CWnd* pParent = NULL);   // standard constructor
	BOOL m_bMode;
	CQuestion *m_pQuestion;
	BOOL m_bCorrect[5];
	int m_intItem;

// Dialog Data
	//{{AFX_DATA(CQEdit)
	enum { IDD = IDD_QUESTION_EDIT };
	CButton	m_cmdChangeFont;
	CButton	m_cmdOK;
	CButton	m_cmdCancel;
	CButton	m_chkReduce;
	CEdit	m_txtReduceTime;
	CEdit	m_txtReduceScore;
	CEdit	m_txtTimeLimit;
	CSpinButtonCtrl	m_spnTime;
	CSpinButtonCtrl	m_spnScore;
	CSpinButtonCtrl	m_spnReduceTime;
	CSpinButtonCtrl	m_spnReduceScore;
	CButton	m_cmdBrowse;
	CButton	m_chkBitmap;
	CEdit	m_txtQuestion;
	CEdit	m_txtBitmap;
	BOOL	m_bUseBitmap;
	CString m_strQuestion;
	UINT	m_intScore;
	UINT	m_intTimeLimit;
	UINT	m_intReduceTime;
	UINT	m_intReduceScore;
	BOOL	m_bTimeLimit;
	BOOL	m_bReduce;
	CString	m_strBitmap;
	BOOL	m_bAllowMultiple;
	BOOL	m_bCustomFont;
	//}}AFX_DATA
	// Class Wizard doesn't recognize control arrays, so put these
	// outside the class wizard's reserved block.
	CStatic	m_lblAnswer[5];
	CEdit	m_txtAnswer[5];
	CButton	m_chkCorrect[5];
	CString m_strAnswer[5];


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CQEdit)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	int Do_Choose_Font();
	LOGFONT m_fontCustom;
	void Set_Button_Styles(UINT nStyle);
	void Enable_Numerics();
	BOOL Validate_Fields();
	BOOL Compare_Fields(void);
	BOOL Compact_Fields(void);

	// Generated message map functions
	//{{AFX_MSG(CQEdit)
	virtual BOOL OnInitDialog();
	afx_msg void OnchkBitmap();
	afx_msg void OncmdBrowse();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnchkTimeLimit();
	afx_msg void OnchkReduce();
	afx_msg void OncmdPreview();
	afx_msg void OnChangetxtBitmap();
	afx_msg void OnChangetxtQuestion();
	afx_msg void OnchkAllowMultiple();
	afx_msg void OnchkCustomFont();
	afx_msg void OncmdChangeFont();
	//}}AFX_MSG
	afx_msg void OnchkCorrect(UINT nID);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_QEDIT_H__3509F441_F049_11D3_A4C6_00A0CC307F9C__INCLUDED_)
